package org.bluej.extensions.mainrunner;

import bluej.extensions2.BClass;
import bluej.extensions2.BMethod;

public class Actor extends Thread {
    private BClass bc;

    public Actor(BClass bc) {
        this.bc = bc;
    }

    public void run() {
        BMethod bm;

        try {
            bm = this.bc.getDeclaredMethod("main", new Class[]{String[].class});
        } catch (Exception ex) {
            System.err.println("MainRunner: can't get main method: " + ex);
            return;
        }

        try {
            // To comply with BlueJ handling of a main method, we should reset the user VM when calling main().
            bc.getPackage().getProject().restartVM();
            // Then we can call main()
            Object o = new Object() {
                public String toString() {
                    return "{}";
                }
            };
            
            // We should not run the method invocation on the Java FX thread. We create a new thread to do this job.
            new Thread(() -> {
                try
                {
                    bm.invoke(null, new Object[]{o});
                }
                catch(Exception ex2){
                    System.err.println("MainRunner: can't invoke main method: " + ex2);
                }
            }).start();
           
        } catch (Exception ex) {
            System.err.println("MainRunner: can't restart VM: " + ex);
        }
    }
}
